﻿//WRITTEN BY GAMEPILL.COM

class GameBoardMC extends GamePiece{
	
	
	//************************************************************
	//PRIVATE VARS
	//************************************************************
	private var real_board:MovieClip;
	//private var userMessage:MovieClip;
	private var PromptMC:MovieClip;
	
	
	private var board:Array;
	private var playerSide:Number;
	private var playerCount:Number;
	private var turn:Number;
	
	public var myRandomInterval:Object;
	public var myRandomIntervalCount:Number;
	public var myRandomTotalSquares:Number;
	
	private var markSquareSound:Sound;
	private var playerWinsSound:Sound;

	
	
	
	
	
	//************************************************************
	//PROPERTIES
	//************************************************************
	
	
	
	

	//************************************************************
	//CONSTRUCTOR FUNCTIONS
	//************************************************************

	public function GameBoardMC(){
		
		trace("GameBoardMC Created");
		//call on super
		makeThisADispatcher();
		
		disableGameBoardMC();
		
		markSquareSound = new Sound(this);
		markSquareSound.attachSound("p2p_gridplay.wav");
		
		playerWinsSound = new Sound(this);
		playerWinsSound.attachSound("p2p_ending.wav");
		

		
		//initGame();
		
	}
	
	
	
	//************************************************************
	//VISUAL FUNCTIONS
	//************************************************************
	private function initialVisuals(){
		
		//userMessage._visible = false;
		
	}
	
	
	//************************************************************
	//INITIAL FUNCTIONS
	//************************************************************
	
	
	
		private function initGame(){
		
			
			trace("INITIATE GAME");
			//feedback.text="Please choose the number of human players. 1 Player plays against the computer."
			turn = 0;
			playerSide = 1;
			playerCount = 1;
			//real_board._visible = false;
			for(var i=0;i<3;++i){
				for(var j=0;j<3;++j){
					
					real_board["b"+i+j].r=i;
					real_board["b"+i+j].c=j;
					
				}
			}
			
			startGame();
	}
	
	
	
		private function startGame(){
		
			trace("START GAME");
			turn = 1;
			//real_board._visible = true;
			board = [[0,0,0],[0,0,0],[0,0,0]];
			board.moveCount = 0;
			
			//set up board square btns
			for(var i=0;i<3;++i)
				
				for(var j=0;j<3;++j){
					real_board["b"+i+j].onRelease = function (){_parent._parent.makeMove(this);};
					real_board["b"+i+j].x._visible = false;
					real_board["b"+i+j].o._visible = false;	
					
				}
				
			for(var i=1;i<9;++i) real_board["winbar"+i]._visible = false;
		
	}
	
	
	//************************************************************
	//PUBLIC GENERAL FUNCTIONS
	//************************************************************
	public function setPromptToUserTurn(){
		
		PromptMC.gotoAndStop("userTurn");
		
		
	}
	
	public function setPromptToComputerTurn(){
		
		PromptMC.gotoAndStop("computerTurn");
		
		
	}
	
	public function setPromptToOff(){
		
		PromptMC.gotoAndStop("off");
		
		
	}
	
	
	
	
	public function allowUserMove(){
		
		//show the user message
		trace("ALLOW USER MOVE");
		setPromptToUserTurn();
		enableGameBoardMC();
		
		
	}
	
	
	
	public function disableGameBoardMC(){
		
		//this._alpha = 50;
		//this.enabled = false;
		for(var i=0;i<3;++i){
			for(var j=0;j<3;++j){
					
					real_board["b"+i+j].enabled = false;
					
				}
			}
		
		
	}
	
	
	
	public function enableGameBoardMC(){
		
		//this._alpha = 100;
		//this.enabled = true;
		for(var i=0;i<3;++i){
			for(var j=0;j<3;++j){
					
					real_board["b"+i+j].enabled = true;
					
				}
			}
		
		
	}
	
	
	
	//makes a square on the board flash for 0.5 sec
	public function flashSquare(row:Number, col:Number){
		
		trace("call square = " + row + " - " + col);
		real_board["b"+row+col].flashingBlueSquareMC.gotoAndPlay("flash");
		
	}
	
	
	
	//************************************************************
	//PRIVATE GENERAL FUNCTIONS
	//************************************************************
	
	
	
	private function makeComputerMove(){	
		
		//if(board.moveCount == 9){trace("end of game"); return;}
		
		//pause the code for a few seconds while the slider moves across
		var pauseCodeExec:Function = function(thisMC){
		
			thisMC.makeComputerMove0();
			
		}
		
		pauseCodeAndCallFunction(2500, pauseCodeExec);
		
	}
	
	
	
	private function makeComputerMove0(){
		
		//run the random square flasher then allow the computer to pick a square
		var availableSquares:Array = getAvaliableWhiteSquares();
		availableSquares = scrambleArray(availableSquares);
		myRandomIntervalCount = 0;
		myRandomTotalSquares = availableSquares.length;
		myRandomInterval = setInterval( randomIntervalFnc, 100, {callingMC:this, squares:availableSquares});
		
	}	


	
	//runs after the random squares have stopped flashing
	private function makeComputerMove1(){
		
		//we need to check if there is a spot where the computer needs to block the player
		var move = findGoodMove();
		var tile = real_board["b"+move.r+move.c];
		executeComputerMove(tile);
		
	}
	
	
	
	private function getAvaliableWhiteSquares():Array{
		
		var tempArray:Array = new Array();
		
		for(var x = 0; x < 3; x++){
			
			for(var y = 0; y < 3; y++){
				
				if(board[x][y] == 0){
					tempArray.push([x,y]);
				}
			}
		}
		return tempArray;
		
	}
	
	
	
	
	
	private function randomIntervalFnc(arg){
		
		arg.callingMC.flashSquare(arg.squares[arg.callingMC.myRandomIntervalCount][0], arg.squares[arg.callingMC.myRandomIntervalCount][1]);
		trace(arg);
		trace(arg.callingMC.myRandomIntervalCount);
		
		
		if(arg.callingMC.myRandomIntervalCount == (arg.callingMC.myRandomTotalSquares - 1)){
			
			//set off the computer move and clear the interval
			//NOTE WE SHOULD PUT A DELAY ON THIS FUNCTION
			arg.callingMC.makeComputerMove1();
			clearInterval(arg.callingMC.myRandomInterval);
			
		}
		
		arg.callingMC.myRandomIntervalCount++;

	}
	
	

	
	
	private function findGoodMove(){

		if(blockingMove() != null){
			
			return blockingMove();
			
		}else{
			
			return makeRandomChoice();
			
		}
}


private function blockingMove():Object{
	
	//check the 8 possible win lines
	var OrangeCount:Number;
	var moveObj:Object = null
	//line1
	
	//check Horizontal rows
	for(var row = 0; row < 3; row++){
		OrangeCount = 0
		for (var col=0; col< 3; col++){
			
			if(board[row][col] == 1){
				OrangeCount++;
			}
		}
		
		//if there was two orange counts then check for a white square
		if(OrangeCount == 2){
			for (var col=0; col< 3; col++){
				
				if(board[row][col] == 0){
					//blocking move needed here
					moveObj = {r:row,c:col};
					return moveObj;
				}
			}
		}
	}
	
	//check Verticle rows
	for(var col = 0; col < 3; col++){
		OrangeCount = 0
		for (var row=0; row< 3; row++){
			
			if(board[row][col] == 1){
				OrangeCount++;
			}
		}
		
		//if there was two orange counts then check for a white square
		if(OrangeCount == 2){
			for (var row=0; row< 3; row++){
				
				if(board[row][col] == 0){
					//blocking move needed here
					moveObj = {r:row,c:col};
					return moveObj;
				}
			}
		}
	}
	
	//check Diagonal rows left-right
	OrangeCount = 0
	for (var x=0; x< 3; x++){
		
		if(board[x][x] == 1){
				OrangeCount++;
			}
	}
	
	//if there was two orange counts then check for a white square
		if(OrangeCount == 2){
			for (var x=0; x< 3; x++){
				
				if(board[x][x] == 0){
					//blocking move needed here
					moveObj = {r:x,c:x};
					return moveObj;
				}
			}
		}
		
	//check Diagonal rows right-left
	OrangeCount = 0
	if(board[0][2] == 1){OrangeCount++;}
	if(board[1][1] == 1){OrangeCount++;}
	if(board[2][0] == 1){OrangeCount++;}
	
	if(OrangeCount == 2){
				
			if(board[0][2] == 0){moveObj = {r:0,c:2};return moveObj;}
			if(board[1][1] == 0){moveObj = {r:1,c:1};return moveObj;}
			if(board[2][0] == 0){moveObj = {r:2,c:0};return moveObj;}
	}
		
	return moveObj;
}


	
	private function makeRandomChoice():Object{
		
		var rr;
		var rc;
	do{
			rr = getRandom(0,2);
			rc = getRandom(0,2);
		}while(board[rr][rc] != 0)
		return {r:rr,c:rc}

	}
	
	
	private function executeComputerMove(tile:MovieClip){
	
		makeOMove(tile);
	
	}
	
	
	//X is the user
	private function makeXMove(mc:MovieClip){
		
		markSquareSound.start();
		board.moveCount++;
		mc.x._visible = true;
		mc.onRelease = null;
		board[mc.r][mc.c] = 1;
		trace("test for win = " + testForWin());
		stopGame(testForWin());
		//disableGameBoardMC();
		trace("X moved");
	
	}
	
	
	//O is the computer
	private function makeOMove(mc:MovieClip){
	
		markSquareSound.start();
		board.moveCount++;
		
		mc.o._visible = true;
		mc.onRelease = null;
		board[mc.r][mc.c] = -1;
		stopGame(testForWin());
	
	}
	
	
	private function stopGame(winner:Number){
		
		setPromptToOff();
		
		trace("STOP GAME = " + winner);
		switch(winner){
			case undefined: return;
			case 0: 
				trace("User Looses!");
				
				//slight pause required here
				var pauseCodeExec:Function = function(thisMC){
					thisMC.dispatchMyEvent("squarePlacedOnBoard", {myMessage:"UserLooses"});
				}
				pauseCodeAndCallFunction(1500, pauseCodeExec);
				//dispatchMyEvent("squarePlacedOnBoard", {myMessage:"UserLooses"});
				return;
				break;
				
			case 1: 
				trace("X wins!");
				
				//slight pause required here
				//var pauseCodeExec:Function = function(thisMC){
				//	thisMC.pauseCodeAndCallFunction(1500, pauseCodeExec);
				//	thisMC.dispatchMyEvent("squarePlacedOnBoard", {myMessage:"UserWins"});
				//}
				//pauseCodeAndCallFunction(1500, pauseCodeExec);
				//playerWinsSound.start();
				dispatchMyEvent("squarePlacedOnBoard", {myMessage:"UserWins"});
				break;
			
			case -1: 
				trace("never happens!");
				//check for full board
				
				//slight pause required here
				//var pauseCodeExec:Function = function(thisMC){
				//	if(thisMC.board.moveCount == 9){thisMC.dispatchMyEvent("squarePlacedOnBoard", {myMessage:"UserLooses"});}else{
				//	thisMC.dispatchMyEvent("squarePlacedOnBoard", {myMessage:"NextQuestion"});}
				//}
				//pauseCodeAndCallFunction(1500, pauseCodeExec);
				
				if(board.moveCount == 9){dispatchMyEvent("squarePlacedOnBoard", {myMessage:"UserLooses"});}else{
				dispatchMyEvent("squarePlacedOnBoard", {myMessage:"NextQuestion"});}
				return;
				break;
				
			case 2:
				trace("nothing matched!");
				//check for full board
				
				//slight pause required here
				//var pauseCodeExec:Function = function(thisMC){
				//	if(thisMC.board.moveCount == 9){thisMC.dispatchMyEvent("squarePlacedOnBoard", {myMessage:"UserLooses"});}else{
				//	thisMC.dispatchMyEvent("squarePlacedOnBoard", {myMessage:"NextQuestion"});}
				//}
				//pauseCodeAndCallFunction(1500, pauseCodeExec);
				
				if(board.moveCount == 9){dispatchMyEvent("squarePlacedOnBoard", {myMessage:"UserLooses"});}else{
				dispatchMyEvent("squarePlacedOnBoard", {myMessage:"NextQuestion"});}
				return;
				break;
				
		}
		
		
		playerCount = turn = playerSide = 0;
		trace("board[0][0]  = " + board[0][0]);
		if(Math.abs(board[0][0]+board[0][1]+board[0][2]) == 3 && board[0][0] == 1) real_board.winbar4._visible=true;
		if(Math.abs(board[1][0]+board[1][1]+board[1][2]) == 3 && board[1][0] == 1) real_board.winbar5._visible=true;
		if(Math.abs(board[2][0]+board[2][1]+board[2][2]) == 3 && board[2][0] == 1) real_board.winbar6._visible=true;
		if(Math.abs(board[0][0]+board[1][0]+board[2][0]) == 3 && board[0][0] == 1) real_board.winbar1._visible=true;
		if(Math.abs(board[0][1]+board[1][1]+board[2][1]) == 3 && board[0][1] == 1) real_board.winbar2._visible=true;
		if(Math.abs(board[0][2]+board[1][2]+board[2][2]) == 3 && board[0][2] == 1) real_board.winbar3._visible=true;
		if(Math.abs(board[0][0]+board[1][1]+board[2][2]) == 3 && board[0][0] == 1) real_board.winbar7._visible=true;
		if(Math.abs(board[0][2]+board[1][1]+board[2][0]) == 3 && board[0][2] == 1) real_board.winbar8._visible=true;
	
	}
	
	
	
	//tests for possible user win
	//private function testForPossibleUserWin():Number{
	
	
	private function testForWin():Number{
		
		
		if(board[0][0] == 1){
			trace("CONDITION 0");
			if(board[0][0]==board[0][1] && board[0][1]==board[0][2])return 1;
			if(board[0][0]==board[1][0] && board[1][0]==board[2][0])return 1;
			if(board[0][0]==board[1][1] && board[1][1]==board[2][2])return 1;
		}
		
		if(board[1][1] == 1){
			trace("CONDITION 1");
			if(board[1][0]==board[1][1] && board[1][1]==board[1][2])return 1;
			if(board[0][1]==board[1][1] && board[1][1]==board[2][1])return 1;
			if(board[0][2]==board[1][1] && board[1][1]==board[2][0])return 1;
		}
		
		if(board[2][2] == 1){
			trace("CONDITION 2");
			if(board[2][0]==board[2][1] && board[2][1]==board[2][2])return 1;
			if(board[0][2]==board[1][2] && board[1][2]==board[2][2])return 1;
		}
		
		if(board.moveCount == 9) return 0;
		
		
	
		
	
		
		//2 nothing matched by above conditions, keep playing
		return 2;
		
	}
	
	
	
	
	//************************************************************
	//HELPER FUNCTIONS
	//************************************************************
	
	
	private function getRandom(minimumVal:Number, maximumVal:Number){
	
		return Math.floor(Math.random() * (maximumVal - minimumVal +1) + minimumVal);

	}
	

	
	//shuffles the ramdom array
	private function scrambleArray(arrayToScramble)
	{
		
		var tempArray = arrayToScramble;
		var arraySize:Number = tempArray.length;
		var numberShuffle:Number = random(15) + 5;

		for (var x = 1; x <= numberShuffle; x++) {
		  for (var y = 0; y < arraySize; y++) {
			var temp = random(arraySize);
			var temp2 = tempArray[y];
			tempArray[y] = tempArray[temp];
			tempArray[temp] = temp2;
		  }
		}
		
		return tempArray;
	}
	
	
	
	
	
	//************************************************************
	//EVENT FUNCTIONS
	//************************************************************
	
	private function makeMove(tileMC:MovieClip){
	
	//trace("MAKE MOVE");
		
		makeXMove(tileMC);
		disableGameBoardMC();
		
	}
	
	private function randomSquareFlashingFinished(){
	
		makeComputerMove1();
		
	}
	
	
	
	//************************************************************
	//CUSTOM EVENT FUNCTIONS
	//************************************************************
	
	
	
	
	
	
	
	
	
	
	
	
}